//      Copyright (C) 2016   E.J.M. Martens
//
//      This program is free software; you can redistribute it and/or
//      modify it under the terms of the GNU General Public License
//      as published by the Free Software Foundation; either version 2
//      of the License, or (at your option) any later version.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program; if not, write to the Free Software
//      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.



#include "CustomProgram.h"
#include <allegro5/allegro_primitives.h>
#include <stdio.h>
#include <stdlib.h>     /* srand, rand */
#include <iostream>
#include "util.h"
#include "MathVectors.h"


CustomProgram::CustomProgram(int a_nScreenWidth, int a_nScreenheight, bool a_blFullscreen)
:A5Program(a_nScreenWidth, a_nScreenheight, a_blFullscreen,false)
{
    srand (time(NULL));
    m_pFontPath  = al_get_standard_path(ALLEGRO_RESOURCES_PATH);
    al_append_path_component(m_pFontPath, "Font");
    al_set_path_filename(m_pFontPath,"arial.ttf");
    const char * szPath = al_path_cstr(m_pFontPath,ALLEGRO_NATIVE_PATH_SEP);
    std::cout << "FontPath: " << szPath << "\n";

    m_pFont = al_load_ttf_font(szPath,10,0);
    m_TextCol = al_map_rgb(255,255,255);


    m_pTileEngine = new BasicEngine();
    m_pTileEngine->GenerateTest(20,20,NULL);

    m_dCameraX = 800;
    m_dCameraY = 600;

    m_dDeltaX = 0;
    m_dDeltaY = 0;

    //m_pTileEngine->DoTest();
    m_vPath = m_pTileEngine->FindPath(2,2,18,18);

}


CustomProgram::~CustomProgram()
{
    delete m_pTileEngine;
}


void CustomProgram::DispatchEvent(ALLEGRO_EVENT * a_pEvent)
{

}


void CustomProgram::OnKeyDown(const ALLEGRO_KEYBOARD_EVENT & a_KeyboardEvent)
{
    switch(a_KeyboardEvent.keycode)
    {
        case ALLEGRO_KEY_ESCAPE:
               Quit();
             break;

        case ALLEGRO_KEY_UP:
             m_dDeltaY = -600;
             break;

        case ALLEGRO_KEY_DOWN:
             m_dDeltaY = 600;
             break;

        case ALLEGRO_KEY_LEFT:
             m_dDeltaX = -600;
             break;

        case ALLEGRO_KEY_RIGHT:
             m_dDeltaX = 600;
             break;


    }


}

void CustomProgram::OnKeyUp(const ALLEGRO_KEYBOARD_EVENT & a_KeyboardEvent)
{
    switch(a_KeyboardEvent.keycode)
    {
        case ALLEGRO_KEY_UP:
             m_dDeltaY = 0;
             break;

        case ALLEGRO_KEY_DOWN:
             m_dDeltaY = 0;
             break;

        case ALLEGRO_KEY_LEFT:
             m_dDeltaX = 0;
             break;

        case ALLEGRO_KEY_RIGHT:
             m_dDeltaX = 0;
             break;

    }

}


void CustomProgram::OnMouseMove(const ALLEGRO_MOUSE_EVENT & a_MouseEvent)
{



}

void CustomProgram::OnMouseButtonDown(const ALLEGRO_MOUSE_EVENT & a_MouseEvent)
{

}

void CustomProgram::OnMouseButtonUp(const ALLEGRO_MOUSE_EVENT & a_MouseEvent)
{

}




void CustomProgram::OnUpdate(double a_dLagTime)
{
  if (m_dDeltaY != 0)
  {
      m_dCameraY += (m_dDeltaY * a_dLagTime);
  }

  if (m_dDeltaX != 0)
  {
      m_dCameraX += (m_dDeltaX * a_dLagTime);
  }
}



void CustomProgram::OnDraw()
{
    m_pTileEngine->Draw(m_dCameraX,m_dCameraY);


}

void CustomProgram::OnTimer()
{


}



